=== added file 'src/com/goldencode/p2j/ui/client/widget/VScrollBar.java'
--- src/com/goldencode/p2j/ui/client/widget/VScrollBar.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/widget/VScrollBar.java	2021-06-09 17:35:01 +0000
@@ -0,0 +1,436 @@
+package com.goldencode.p2j.ui.client.widget;
+
+import java.awt.event.*;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+import com.goldencode.p2j.ui.client.gui.theme.*;
+import com.goldencode.p2j.ui.client.model.*;
+
+public final class VScrollBar extends AbstractScrollBar
+{
+
+   /**
+    * The (only) constructor for this widget.
+    * 
+    * @param model the scrolling model.
+    */
+   public VScrollBar(ScrollModel model)
+   {
+      super(model);
+   }
+
+   @Override
+   protected void doDraw(GuiDriver<?, ?> gd, GuiColorResolver gc)
+   {
+      final NativeDimension dim = physicalDimension();
+      final int scrollBarHeight = dim.height;
+      final Theme theme = ThemeManager.getCurrentTheme();
+
+      // fill in scroll bar area
+      theme.drawScrollBarGauge(gd, gc, 0, 0, dim.width, scrollBarHeight,
+               false /* isHorizontal */);
+
+      final int buttonLongDim = Math.min(scrollBarHeight / 2, theme.getScrollBarButtonHeight());
+
+      /**
+       * The length between the lefttop and bottom buttons
+       */
+      final int interButtonLength = scrollBarHeight - 2 * buttonLongDim;
+
+      /**
+       * Check for the case the widget width is not enough for just two buttons.
+       * In this case neither buttons nor thumb should not be visible.
+       */
+      if (interButtonLength < 0)
+      {
+         return;
+      }
+
+      final int buttonShortDim = theme.getScrollBarButtonWidth();
+
+      /**
+       * We center the vertical scrollbar horizontally
+       */
+      final int buttonX = (dim.width - buttonShortDim) / 2;
+
+      // draw left/top button
+      ThemeManager.getCurrentTheme().drawScrollBarButton(gd, gc, buttonX, 0, buttonShortDim,
+               buttonLongDim, ScrollBar.Position.LEFT, false, true,
+               lastPressedPart == Part.LEFT_BUTTON, lastHoverPart == Part.LEFT_BUTTON);
+
+      // draw right/bottom button
+      ThemeManager.getCurrentTheme().drawScrollBarButton(gd, gc, buttonX,
+               scrollBarHeight - buttonLongDim, buttonShortDim, buttonLongDim,
+               ScrollBar.Position.RIGHT, false, true, lastPressedPart == Part.RIGHT_BUTTON,
+               lastHoverPart == Part.RIGHT_BUTTON);
+
+      final int thumbMinWidth = theme.getScrollBarThumbMinSize();
+      if (interButtonLength < thumbMinWidth)
+      {
+         /**
+          * Scrollbar is too narrow for any thumb to be drawn
+          */
+         return;
+      }
+
+      final int modelWidth = model.getWidth();
+      final int modelPosition = model.getPosition();
+
+      /**
+       * Note: we calculate the gap between the thumb and the bottom button
+       * instead of thumb size. Otherwise we can get the 1-pixel gap between the
+       * thumb and the button at the end of thumb travel, which is visible to the
+       * user. We prefer to get slightly incorrect thumb size, which is hardly
+       * seen with the naked eye.
+       */
+      /**
+       * We must treat zero-width case specially to prevent division by zero. 
+       */
+      final boolean isDegeneratedCase = modelWidth == 0;
+
+      final int thumbEndLimit = scrollBarHeight - buttonLongDim;
+      int thumbEnd = thumbEndLimit;
+      if (!isDegeneratedCase)
+      {
+         thumbEnd -= (modelWidth - model.getLastVisible()) * interButtonLength / modelWidth;
+      }
+
+      int thumbPosY = buttonLongDim;
+      if (!isDegeneratedCase)
+      {
+         thumbPosY += interButtonLength * modelPosition / modelWidth;
+      }
+
+      int thumbWidth = thumbEnd - thumbPosY;
+
+      /**
+       * Test if the thumb is too narrow, try to handle this
+       */
+      final int thumbInflateNeeded = thumbMinWidth - thumbWidth;
+      if (thumbInflateNeeded > 0)
+      {
+         /**
+          * The 'true' calculated thumb width is to small to be usable, so we try
+          * to increase it.
+          */
+         /**
+          * Note: the check above guarantees, that the inter-button space here is wide enough
+          * to contain a thumb of a minimum thumb width.
+          */
+         thumbWidth = thumbMinWidth;
+         final int halfIncrease = thumbInflateNeeded / 2;
+         thumbPosY = Math.min(Math.max(thumbPosY - halfIncrease, 0), thumbEndLimit - thumbWidth);
+      }
+
+      final int thumbSize = theme.getScrollBarThumbWidth();
+
+      final boolean thumbPressed = lastPressedPart == Part.THUMB;
+      final boolean thumbHover = lastHoverPart == Part.THUMB;
+
+      final int thumbPosX = (dim.width - thumbSize) / 2;
+
+      theme.drawScrollBarThumb(gd, gc, thumbPosX, thumbPosY, thumbSize, thumbWidth, thumbPressed,
+               thumbHover, false);
+   }
+
+   @Override
+   public Dimension minimumSize()
+   {
+      @SuppressWarnings("null")
+      CoordinatesConversion cc = screen().coordinates();
+      return new Dimension(cc.columnFromPixels(minWidth()), cc.rowFromPixels(minLength()));
+   }
+
+   @Override
+   public void mouseDragged(/* @Nullable */ MouseEvent e)
+   {
+      if (lastPressedPart != Part.THUMB)
+      {
+         /**
+          * Effectively disallow any other mouse operation after the
+          * mouse pointer was dragged not by the thumb. Allowing it
+          * may look a bit weird from the user stand point.
+          */
+         lastPressedPart = Part.NONE;
+         return;
+      }
+
+      assert e != null;
+
+      NativeDimension dim = physicalDimension();
+      int scrollBarHeight = dim.height;
+      Theme theme = ThemeManager.getCurrentTheme();
+
+      int buttonLongDim = Math.min(scrollBarHeight / 2, theme.getScrollBarButtonHeight());
+
+      /**
+       * The length between the left and right buttons
+       */
+      int interButtonLength = scrollBarHeight - 2 * buttonLongDim;
+
+      /**
+       * Check for the case the widget width is not enough for two
+       * buttons and minimum thumb.
+       *
+       */
+      final int thumbMinWidth = theme.getScrollBarThumbMinSize();
+      if (interButtonLength < thumbMinWidth)
+      {
+         /**
+          * FIXME: in this situation the drag start should nod be
+          * possible, so it is better replace the return statement by
+          * an assertion.
+          */
+         return;
+      }
+
+      /**
+       * Note: we calculate the gap between the thumb and the bottom button
+       * instead of thumb size. Otherwise we can get the 1-pixel gap between the
+       * thumb and the button at the end of thumb travel, which is visible to the
+       * user. We prefer to get slightly incorrect thumb size, which is hardly
+       * seen with the naked eye.
+       */
+      int modelPage = model.getPage();
+      int modelWidth = model.getWidth();
+      int modelPosition = model.getPosition();
+
+      /**
+       * We must treat zero-width case specially to prevent division by zero. 
+       */
+      boolean isDegeneratedCase = modelWidth == 0;
+
+      final int thumbEndLimit = scrollBarHeight - buttonLongDim;
+      int thumbEnd = thumbEndLimit;
+      if (!isDegeneratedCase)
+      {
+         thumbEnd -= (modelWidth - modelPage - modelPosition) * interButtonLength / modelWidth;
+      }
+
+      int thumbPosY = buttonLongDim;
+      if (!isDegeneratedCase)
+      {
+         thumbPosY += interButtonLength * modelPosition / modelWidth;
+      }
+
+      int thumbWidth = thumbEnd - thumbPosY;
+
+      /**
+       * Test if the thumb is too narrow, try to handle this
+       */
+      final int thumbInflateNeeded = thumbMinWidth - thumbWidth;
+      if (thumbInflateNeeded > 0)
+      {
+         /**
+          * The 'true' calculated thumb width is to small to be usable, so we try
+          * to increase it.
+          */
+         /**
+          * Note: the check above guarantees, that the inter-button space here is wide enough
+          * to contain a thumb of a minimum thumb width.
+          */
+         thumbWidth = thumbMinWidth;
+      }
+
+      /**
+       * Topmost vertical position
+       */
+      final int maxPosY = interButtonLength - thumbWidth;
+
+      final int maxModelPosition = modelWidth - modelPage;
+      final int offset = e.getY() - lastMousePos;
+      final int newModelPosition = maxPosY > 0 ? lastModelPos + offset * maxModelPosition / maxPosY : 0;
+      model.setPosition(Math.min(maxModelPosition, Math.max(0, newModelPosition)));
+   }
+
+   /**
+    * Update the {@link #lastHoverPart} and {@link #highLightedRect} field values
+    * when the mouse position changes.
+    * 
+    * @param x
+    *        the X coordinate
+    * @param y
+    *        the Y coordinate
+    * @return see above.
+    */
+   @Override
+   protected void updateMouseHitInfo(int x, int y)
+   {
+      NativeDimension dim = physicalDimension();
+      NativePoint p = screenPhysicalLocation();
+      int localY = y - p.y;
+
+      int scrollBarHeight = dim.height;
+      if (localY < 0 || localY >= scrollBarHeight)
+      {
+         /**
+          * Mouse is out of widget vertical bounds
+          */
+         lastHoverPart = Part.NONE;
+         highLightedRect = null;
+         return;
+      }
+
+      Theme theme = ThemeManager.getCurrentTheme();
+      int buttonLongDim = Math.min(scrollBarHeight / 2, theme.getScrollBarButtonHeight());
+
+      /**
+       * The length between the left and right buttons
+       */
+      int interButtonLength = scrollBarHeight - 2 * buttonLongDim;
+
+      /**
+       * Check for the case the widget width is not enough for just two buttons.
+       * In this case the buttons should not be visible, and the scrollbar is unusable.
+       */
+      if (interButtonLength < 0)
+      {
+         lastHoverPart = Part.NONE;
+         highLightedRect = null;
+         return;
+      }
+
+      // compute buttons size
+
+      int buttonShortDim = theme.getScrollBarButtonWidth();
+
+      int rectLeft = (dim.width - buttonShortDim) / 2;
+
+      int localX = x - p.x;
+      if ((localX < rectLeft) || (localX >= (rectLeft + buttonShortDim)))
+      {
+         lastHoverPart = Part.NONE;
+         highLightedRect = null;
+         return;
+      }
+
+      /**
+       * Now the pointer is in the widget active area.
+       */
+      int rectTop;
+      int rectBottom;
+
+      if (localY < buttonLongDim)
+      {
+         // Top button
+         rectTop = 0;
+         rectBottom = buttonLongDim;
+         lastHoverPart = Part.LEFT_BUTTON;
+      }
+      else
+      {
+         final int thumbEndLimit = scrollBarHeight - buttonLongDim;
+         if (localY >= thumbEndLimit)
+         {
+            // Bottom button
+            rectTop = thumbEndLimit;
+            rectBottom = scrollBarHeight;
+            lastHoverPart = Part.RIGHT_BUTTON;
+         }
+         else
+         {
+            /**
+             * Pointer is between the buttons.
+             */
+            final int thumbMinWidth = theme.getScrollBarThumbMinSize();
+            if (interButtonLength < thumbMinWidth)
+            {
+               /**
+                * Scrollbar is too narrow for any thumb to be drawn
+                */
+               lastHoverPart = Part.NONE;
+               highLightedRect = null;
+               return;
+            }
+
+            int modelWidth = model.getWidth();
+            int modelPosition = model.getPosition();
+
+            /**
+             * We must treat zero-width case specially to prevent division by zero. 
+             */
+            boolean isDegeneratedCase = modelWidth == 0;
+
+            int thumbEnd = thumbEndLimit;
+            if (!isDegeneratedCase)
+            {
+               thumbEnd -= (modelWidth - model.getLastVisible()) * interButtonLength / modelWidth;
+            }
+
+            int thumbPosY = buttonLongDim;
+            if (!isDegeneratedCase)
+            {
+               thumbPosY += interButtonLength * modelPosition / modelWidth;
+            }
+
+            int thumbWidth = thumbEnd - thumbPosY;
+
+            /**
+             * Test if the thumb is too narrow, try to handle this
+             */
+            final int thumbInflateNeeded = thumbMinWidth - thumbWidth;
+            if (thumbInflateNeeded > 0)
+            {
+               /**
+                * The 'true' calculated thumb width is to small to be usable, so we try
+                * to increase it.
+                */
+               /**
+                * Note: the check above guarantees, that the inter-button space here is wide enough
+                * to contain a thumb of a minimum thumb width.
+                */
+               thumbWidth = thumbMinWidth;
+               final int halfIncrease = thumbInflateNeeded / 2;
+               thumbPosY = Math.min(Math.max(thumbPosY - halfIncrease, 0),
+                        thumbEndLimit - thumbWidth);
+            }
+
+            if (localY < thumbPosY)
+            {
+               // Top area
+               rectTop = buttonLongDim;
+               rectBottom = thumbPosY;
+               lastHoverPart = Part.LEFT_AREA;
+            }
+            else if (localY < thumbPosY + thumbWidth)
+            {
+               // Thumb
+               rectTop = thumbPosY;
+               rectBottom = thumbPosY + thumbWidth;
+               lastHoverPart = Part.THUMB;
+            }
+            else
+            {
+               // Bottom area
+               rectTop = thumbEndLimit;
+               rectBottom = scrollBarHeight;
+               lastHoverPart = Part.RIGHT_AREA;
+            }
+         }
+      }
+
+      highLightedRect = new NativeRectangle(rectLeft, rectTop, rectLeft + buttonShortDim,
+               rectBottom).translate(p);
+   }
+
+   @Override
+   public void mousePressed(/* @Nullable */ MouseEvent e)
+   {
+      assert e != null;
+      final int x = e.getX();
+      final int y = e.getY();
+      lastMousePos = y;
+      lastModelPos = model.getPosition();
+      updateMouseHitInfo(x, y);
+      if (lastPressedPart != lastHoverPart)
+      {
+         lastPressedPart = lastHoverPart;
+         // FIXME: repaint rectangle instead of whole widget area
+         repaint();
+      }
+   }
+
+}

=== modified file 'src/com/goldencode/p2j/ui/ocx/TreeViewNodeObject.java'
--- src/com/goldencode/p2j/ui/ocx/TreeViewNodeObject.java	2020-02-23 22:22:28 +0000
+++ src/com/goldencode/p2j/ui/ocx/TreeViewNodeObject.java	2021-06-16 22:43:05 +0000
@@ -78,7 +78,7 @@
 extends ComObject
 {
    /** TreeView node */
-   private TreeViewNodeResource node = null;
+   private TreeNodeResource node = null;
    
    /**
     * Constructor.
@@ -86,7 +86,7 @@
     * @param   node
     *          Node entry.
     */
-   private TreeViewNodeObject(TreeViewNodeResource node)
+   private TreeViewNodeObject(TreeNodeResource node)
    {
       this.node = node;
    }
@@ -99,7 +99,7 @@
     *          
     * @return a new instance wrapped as a comhandle.
     */
-   public static comhandle newInstance(TreeViewNodeResource node)
+   public static comhandle newInstance(TreeNodeResource node)
    {
       return node == null ? new comhandle() : new comhandle(new TreeViewNodeObject(node));
    }

=== modified file 'src/com/goldencode/p2j/util/handle.java'
--- src/com/goldencode/p2j/util/handle.java	2021-06-15 16:00:01 +0000
+++ src/com/goldencode/p2j/util/handle.java	2021-06-17 17:43:13 +0000
@@ -3433,7 +3433,7 @@
     *
     * @return   See above.
     */
-   public TreeNodeCollection<?> unwrapTreeNodeCollection()
+   public TreeNodeCollection unwrapTreeNodeCollection()
    {
       return unwrapImpl(this, TreeNodeCollection.class);
    }

=== added file 'src/com/goldencode/util/AbstractPrintable.java'
--- src/com/goldencode/util/AbstractPrintable.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/util/AbstractPrintable.java	2021-06-12 17:10:47 +0000
@@ -0,0 +1,60 @@
+package com.goldencode.util;
+
+import com.google.common.base.*;
+import com.google.common.base.MoreObjects.*;
+
+/**
+ * {@link AbstractPrintable} provides a convenient ancestor for classes willing
+ * to implement the {@link #toString()} method using {@link ToStringHelper}.
+ * 
+ * Subclasses are supposed to redefine the
+ * {@link #updateStringHelper(ToStringHelper)} method.
+ * 
+ */
+public class AbstractPrintable
+{
+   /**
+   * Add class-specific fields to the helper.
+   * 
+   * The subclasses are supposed to override this method to add their
+   * own field info.
+   * 
+   * The default implementation does nothing.
+   *  
+   * @param stringHelper the string helper to update
+   */
+   protected void updateStringHelper(final ToStringHelper stringHelper)
+   {
+      // no-op
+   }
+
+   /**
+    * Returns a string representation of the object. In general, the
+    * {@code toString} method returns a string that
+    * "textually represents" this object. The result should
+    * be a concise but informative representation that is easy for a
+    * person to read.
+    * It is recommended that all subclasses override this method.
+    * <p>
+    * The {@code toString} method for class {@code Object}
+    * returns a string consisting of the name of the class of which the
+    * object is an instance, the at-sign character `{@code @}', and
+    * the unsigned hexadecimal representation of the hash code of the
+    * object. In other words, this method returns a string equal to the
+    * value of:
+    * <blockquote>
+    * <pre>
+    * getClass().getName() + '@' + Integer.toHexString(hashCode())
+    * </pre></blockquote>
+    *
+    * @return  a string representation of the object.
+    */
+   @SuppressWarnings("null")
+   @Override
+   public final String toString()
+   {
+      final ToStringHelper stringHelper = MoreObjects.toStringHelper(this);
+      updateStringHelper(stringHelper);
+      return stringHelper.toString();
+   }
+}

